/**********************************************************************
 *
 * source.cpp -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: source.cpp 249 1999-04-30 02:00:48Z sjboddie $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.3  1999/04/30 02:00:48  sjboddie
   lots of stuff to do with getting documentaction working

   Revision 1.2  1999/04/06 22:20:32  rjmcnab
   Got browsefilter working.

   Revision 1.1  1999/03/31 23:43:40  rjmcnab
   Initial revision

 */


#include "source.h"
#include <assert.h>


// default constructor does nothing
sourceclass::sourceclass () {
}

// default destructor does nothing
sourceclass::~sourceclass () {
}

// configure should be called once for each configuration line
// default does nothing
void sourceclass::configure (const text_t &/*key*/, const text_tarray &/*cfgline*/) {
}

// init should be called after all the configuration is done but
// before any other methods are called
// default does nothing
bool sourceclass::init (ostream &/*logout*/) {
  return true;
}


// translate_OID translates OIDs using ".pr", ."fc" etc.
bool sourceclass::translate_OID (const text_t &/*OIDin*/, text_t &/*OIDout*/, 
				 comerror_t &err, ostream &/*logout*/) {
  err = noError;

  return false;
}


// get_metadata fills out the metadata if possible, if it is not responsable
// for the given OID then it will return false.
bool sourceclass::get_metadata (const text_t &/*requestParams*/, const text_t &/*refParams*/, 
				const text_tarray &/*fields*/, const text_t &/*OID*/,
				MetadataInfo_tarray &metadata, 
				comerror_t &err, ostream &/*logout*/) {
  metadata.erase(metadata.begin(), metadata.end());
  err = noError;

  return false;
}



// thesource remains the property of the calling code but
// should not be deleted until it is removed from this list.
void sourcelistclass::addsource (sourceclass *thesource) {
  // can't add a source that doesn't exist
  assert (thesource != NULL);
  if (thesource == NULL) return;

  sourceptr sp;
  sp.s = thesource;

  sourceptrs.push_back(sp);
}
